<?php
/**
 * Open Source Social Network
 * @link      https://www.opensource-socialnetwork.org/
 * @package   Pinned Posts
 * @author    Michael Zülsdorff <ossn@z-mans.net>
 * @copyright (C) Michael Zülsdorff
 * @license   GNU General Public License https://www.gnu.de/documents/gpl-2.0.en.html
 */

define('PINNED_POSTS', ossn_route()->com . 'PinnedPosts/');

ossn_register_callback('ossn', 'init', function() {
		if (ossn_isAdminLoggedin()) {
				ossn_register_com_panel('PinnedPosts', 'settings');
				ossn_register_action('PinnedPosts/save', PINNED_POSTS . 'actions/settings.php');
		}
		if (ossn_isLoggedin()) {
				ossn_extend_view('ossn/js/head', 'com_pinned_posts');
				// use these hooks as suggested by Arsalan to suppress duplicate posts
				// on https://www.opensource-socialnetwork.org/discussion/view/6844?offset=2
				ossn_add_hook('wall', 'getAllPosts', 'com_pinned_posts_exclude_duplicates');
				ossn_add_hook('wall', 'getPublicPosts', 'com_pinned_posts_exclude_duplicates');
				ossn_add_hook('wall', 'getFriendsPosts', 'com_pinned_posts_exclude_duplicates');
		}
});

function com_pinned_posts() {
		$component = new OssnComponents;
		$settings  = $component->getSettings("PinnedPosts");
		if (isset($settings->PinnedPosts) && !empty($settings->PinnedPosts)) {
				return ossn_plugin_view('PinnedPosts/posts', array(
						'pinnedposts' => $settings
				));
		}
}

function com_pinned_posts_exclude_duplicates($hook, $type, $return, $params){
		$component = new OssnComponents;
		// get the settings of this component
		$settings  = $component->getSettings("PinnedPosts");
		// check, if we have saved one or more post ids to be pinned?
		if (isset($settings->PinnedPosts) && !empty($settings->PinnedPosts)) {
				// yes we have!
				// so let's extend the original SQL query to exclude these post ids
				$return['wheres'] = "o.guid NOT IN ({$settings->PinnedPosts})";
				// and stop her and see how the resulting query looks like ....
				$return['order_by'] = 'CRASH_ME!';
				return $return;
		}
}
